"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const yargs_1 = __importDefault(require("yargs"));
const error_1 = require("./error");
class Args {
    constructor(args) {
        this.file = args.file;
        this.output_path = args.o;
        if (!fs_1.default.existsSync(this.file))
            throw new error_1.ArgsError(`source file \`${this.file}\` doesn't exists`);
    }
    static parse() {
        const args = yargs_1.default
            .scriptName('generz')
            .command('$0 <file>', 'compiles an .erz source file')
            .option('o', {
            alias: 'output',
            demandOption: true,
            describe: 'the output file',
            type: 'string'
        })
            .parse();
        return new Args(args);
    }
}
exports.default = Args;
//# sourceMappingURL=args.js.map