"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Declaration = exports.DeclarationType = void 0;
const node_1 = require("./node");
var DeclarationType;
(function (DeclarationType) {
    DeclarationType["TERMINAL"] = "TERMINAL";
    DeclarationType["VARIABLE"] = "VARIABLE";
    DeclarationType["DELIMITER"] = "DELIMITER";
})(DeclarationType || (exports.DeclarationType = DeclarationType = {}));
class Declaration extends node_1.Node {
    constructor(location, type, name) {
        super(location);
        this.type = type;
        this.name = name;
    }
    is_variable() {
        return this.type === DeclarationType.VARIABLE;
    }
    is_terminal() {
        return this.type === DeclarationType.TERMINAL;
    }
    is_delimiter() {
        return this.type === DeclarationType.DELIMITER;
    }
}
exports.Declaration = Declaration;
//# sourceMappingURL=declaration.js.map