"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TerminalUsage = void 0;
const production_node_1 = require("./production-node");
const error_1 = require("../error");
class TerminalUsage extends production_node_1.ProductionNode {
    set reference(value) {
        this._reference = value;
    }
    get reference() {
        if (this._reference === undefined)
            throw new error_1.InternalError(`Trying to get a reference to the terminal \`${this.name}\` that was not set yet.`);
        return this._reference;
    }
    constructor(location, name) {
        super(location, production_node_1.ProductionNodeType.TERMINAL_USAGE, name);
    }
}
exports.TerminalUsage = TerminalUsage;
//# sourceMappingURL=terminal-usage.js.map