"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Variable = void 0;
const declaration_1 = require("./declaration");
class Variable extends declaration_1.Declaration {
    constructor(location, name, productions) {
        super(location, declaration_1.DeclarationType.VARIABLE, name);
        let epsilon = false;
        this.productions = productions.filter(production => {
            if (!production.is_epsilon())
                return true;
            epsilon = true;
            return false;
        });
        this.epsilon = epsilon;
    }
    get terminals_maps() {
        if (this._terminals_maps === undefined) {
            this._terminals_maps = [];
            for (const production of this.productions) {
                for (const terminals_map of production.terminals_maps) {
                    this._terminals_maps.push(terminals_map);
                }
            }
        }
        return this._terminals_maps;
    }
}
exports.Variable = Variable;
//# sourceMappingURL=variable.js.map