"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalError = exports.CodeError = exports.ArgsError = exports.GenerzError = exports.GenerzErrorType = void 0;
var GenerzErrorType;
(function (GenerzErrorType) {
    GenerzErrorType[GenerzErrorType["ARGS"] = 0] = "ARGS";
    GenerzErrorType[GenerzErrorType["CODE"] = 1] = "CODE";
    GenerzErrorType[GenerzErrorType["INTERNAL"] = 2] = "INTERNAL";
})(GenerzErrorType || (exports.GenerzErrorType = GenerzErrorType = {}));
class GenerzError extends Error {
    constructor(type, message) {
        super(message);
        this.type = type;
    }
}
exports.GenerzError = GenerzError;
class ArgsError extends GenerzError {
    constructor(description) {
        super(GenerzErrorType.ARGS, `${description}`);
        this.description = description;
    }
}
exports.ArgsError = ArgsError;
class CodeError extends GenerzError {
    constructor(file, location, description) {
        super(GenerzErrorType.CODE, `error: ${file}:${location.get_location()} ${description}`);
        this.file = file;
        this.location = location;
        this.description = description;
    }
}
exports.CodeError = CodeError;
class InternalError extends GenerzError {
    constructor(description) {
        super(GenerzErrorType.INTERNAL, `INTERNAL ERROR: ${description}`);
        this.description = description;
    }
}
exports.InternalError = InternalError;
//# sourceMappingURL=error.js.map