"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VariableDeclaration = exports.VariableType = void 0;
const declaration_1 = require("./declaration");
const variable_reference_1 = require("./variable-reference");
var VariableType;
(function (VariableType) {
    VariableType[VariableType["VOID"] = 0] = "VOID";
    VariableType[VariableType["I32"] = 1] = "I32";
})(VariableType || (exports.VariableType = VariableType = {}));
class VariableDeclaration extends declaration_1.Declaration {
    constructor(type, name, options) {
        super(options);
        this.type = type;
        this.name = name;
        this.initial_value = options?.initial_value;
        this.mutable = options?.mutable === true;
        this.reference = new variable_reference_1.VariableReference(this);
    }
    get_reference() {
        return this.reference;
    }
}
exports.VariableDeclaration = VariableDeclaration;
//# sourceMappingURL=variable-declaration.js.map