"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractSymbol = void 0;
const integer_intervals_set_1 = require("../utils/integer-intervals-set");
class AbstractSymbol {
    constructor(set) {
        this.set = set;
    }
    contains(code) {
        return this.set.contains(code);
    }
    contains_only(code) {
        const intervals = this.set.get_intervals();
        return intervals.length === 1 && intervals[0].start === code && intervals[0].end === code + 1;
    }
    represents_something() {
        return this.set.capacity !== 0;
    }
    static fragment(first, second) {
        const result = integer_intervals_set_1.IntegerIntervalsSet.calculate_differences_and_intersection(first.set, second.set);
        const first_exclusive = new AbstractSymbol(result.left_difference);
        const second_exclusive = new AbstractSymbol(result.right_difference);
        const shared = new AbstractSymbol(result.intersection);
        return {
            first_exclusive,
            second_exclusive,
            shared
        };
    }
    static merge(first, second) {
        return new AbstractSymbol(integer_intervals_set_1.IntegerIntervalsSet.calculate_union(first.set, second.set));
    }
    static negate(symbol) {
        return new AbstractSymbol(integer_intervals_set_1.IntegerIntervalsSet.calculate_negation(symbol.set));
    }
}
exports.AbstractSymbol = AbstractSymbol;
//# sourceMappingURL=abstract-symbol.js.map