"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiSymbol = void 0;
const abstract_symbol_1 = require("./abstract-symbol");
const integer_intervals_set_1 = require("../utils/integer-intervals-set");
class MultiSymbol extends abstract_symbol_1.AbstractSymbol {
    constructor(intervals) {
        super((() => {
            const set = new integer_intervals_set_1.IntegerIntervalsSet();
            for (let interval of intervals)
                set.add(interval);
            return set;
        })());
    }
}
exports.MultiSymbol = MultiSymbol;
//# sourceMappingURL=multi-symbol.js.map