"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SingleSymbol = void 0;
const abstract_symbol_1 = require("./abstract-symbol");
const integer_intervals_set_1 = require("../utils/integer-intervals-set");
class SingleSymbol extends abstract_symbol_1.AbstractSymbol {
    constructor(code_point) {
        super((() => {
            const set = new integer_intervals_set_1.IntegerIntervalsSet();
            set.add(code_point);
            return set;
        })());
        this.code_point = code_point;
    }
    to_string() {
        return String.fromCodePoint(this.code_point);
    }
}
exports.SingleSymbol = SingleSymbol;
//# sourceMappingURL=single-symbol.js.map