"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Location = exports.Point = void 0;
class Point {
    constructor(line, column) {
        this.line = line;
        this.column = column;
    }
    get_location() {
        return new Location(this, this);
    }
    toString() {
        return `${this.line}:${this.column}`;
    }
}
exports.Point = Point;
class Location {
    constructor(start, end) {
        this.start = start;
        this.end = end;
    }
    get_location() {
        return this;
    }
    is_point() {
        return this.start.line === this.end.line
            && this.start.column === this.end.column;
    }
    toString() {
        return this.is_point()
            ? this.start.toString()
            : `${this.start}-${this.end}`;
    }
}
exports.Location = Location;
//# sourceMappingURL=location.js.map